import { PDFDocumentProxy, PDFPageViewport } from "pdfjs-dist";
export declare type BoundingRect = {
    left: number;
    top: number;
    width: number;
    height: number;
};
export declare type Scaled = {
    x1: number;
    y1: number;
    x2: number;
    y2: number;
    width: number;
    height: number;
};
export declare type Position = {
    boundingRect: BoundingRect;
    rects: Array<BoundingRect>;
    pageNumber: number;
};
export declare type EventBus = {
    on: (eventName: string, callback: () => void) => void;
    off: (eventName: string, callback: () => void) => void;
};
export declare type Viewer = {
    container: HTMLDivElement;
    viewer: HTMLDivElement;
    getPageView: (page: number) => {
        textLayer: {
            textLayerDiv: HTMLDivElement;
        };
        viewport: PDFPageViewport;
        div: HTMLDivElement;
        canvas: HTMLCanvasElement;
    };
    setDocument: (document: PDFDocumentProxy) => Promise<void>;
    scrollPageIntoView: (options: {
        pageNumber: number;
        destArray: Array<any>;
    }) => void;
    currentScaleValue: string;
};
export declare type LinkService = {
    setDocument: (document: Object) => void;
    setViewer: (viewer: Viewer) => void;
};
