"use strict";
// "viewport" rectangle is { top, left, width, height }
Object.defineProperty(exports, "__esModule", { value: true });
exports.scaledToViewport = exports.viewportToScaled = void 0;
var viewportToScaled = function (rect, _a) {
    var width = _a.width, height = _a.height;
    return {
        x1: rect.left,
        y1: rect.top,
        x2: rect.left + rect.width,
        y2: rect.top + rect.height,
        width: width,
        height: height,
    };
};
exports.viewportToScaled = viewportToScaled;
var pdfToViewport = function (pdf, viewport) {
    var _a = viewport.convertToViewportRectangle([pdf.x1, pdf.y1, pdf.x2, pdf.y2]), x1 = _a[0], y1 = _a[1], x2 = _a[2], y2 = _a[3];
    return {
        left: x1,
        top: y1,
        width: x2 - x1,
        height: y1 - y2,
    };
};
var scaledToViewport = function (scaled, viewport, usePdfCoordinates) {
    if (usePdfCoordinates === void 0) { usePdfCoordinates = false; }
    var width = viewport.width, height = viewport.height;
    if (usePdfCoordinates) {
        return pdfToViewport(scaled, viewport);
    }
    if (scaled.x1 === undefined) {
        throw new Error("You are using old position format, please update");
    }
    var x1 = (width * scaled.x1) / scaled.width;
    var y1 = (height * scaled.y1) / scaled.height;
    var x2 = (width * scaled.x2) / scaled.width;
    var y2 = (height * scaled.y2) / scaled.height;
    return {
        left: x1,
        top: y1,
        width: x2 - x1,
        height: y2 - y1,
    };
};
exports.scaledToViewport = scaledToViewport;
